/* Example: structures as function arguments and return values */

#include <stdio.h>

struct cplx {
              double real;  /* real part */
              double imag;  /* imaginary part */
            };

struct cplx add(struct cplx a, struct cplx b);  /* function prototype */


void main(void)
{
  struct cplx x = {2.5, 5.0}, y = {3.2, -1.7}, z;
  
  z = add(x, y);
  printf("z = %4.2f + %4.2f j\n", z.real, z.imag);
  return;
}


struct cplx add(struct cplx a, struct cplx b)
{
  struct cplx c = a;  /* can initialise an auto struct variable */
  
  c.real += b.real;
  c.imag += b.imag;
  return c;           /* can return a struct value */
}
